package plugin;

import java.text.ParseException;

import plop.astro.Astrocoo;
import plop.astro.Astroframe;
import plop.astro.Astropos;
import plop.astro.FK5;
import plop.astro.ICRS;



public class AstroEpoch extends Astropos {

	/**
	 * this methods calculated the new coordinate in an other equinox
	 * 
	 * @param ra The right ascencion in deg
	 * @param dec the declinaison in deg
	 * @param pmra the ra proper motion in mas/yr
	 * @param pmdec the dec proper motion in mas/yr
	 * @param startdate the equinox which ra and dec are given
	 * @param outdate the equinox which we would like calculated ra and dec 
	 * @return String table containing the new coordinate in degrees 
	 */
	public String[] newCoords(double ra, double dec, double pmra, double pmdec,double startdate,double outdate){
		
		//pmra =(pmra/Math.cos(Math.toRadians(dec)));
		Astroframe frame = new ICRS();
		Astropos starpos = new Astropos(frame, ra, dec, startdate, pmra, pmdec);
		//System.out.println(starpos.epoch+" avant "+starpos.getLon()+" "+starpos.getLat()+" "+starpos.getProperMotionLon()+" "+starpos.getProperMotionLat());
		//super.set(ra, dec, startdate, pmra, pmdec);
		// Change the epoch of the position (in the same frame)
	 //   System.out.println(starpos.x+" "+starpos.y+" "+starpos.z);
	    //date en année julian
		//super.toEpoch(outdate);
	    starpos.toEpoch(outdate);
	   // System.out.println("Lon="+starpos.lon);
	//	System.out.println(starpos.epoch+" apres "+starpos.getLon()+" "+starpos.getLat()+" "+starpos.getProperMotionLon()+" "+starpos.getProperMotionLat());
	   // System.out.println(starpos.x+" "+starpos.y+" "+starpos.z);

		String[] radec ={"",""};
		radec[0]=Double.toString(starpos.getLon());
		radec[1]=Double.toString(starpos.getLat());
		
		return radec;
		
		
		
	}

	public AstroEpoch() {
		super();
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astrocoo coo) {
		super(coo);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astroframe frame, double lon, double lat, double epoch,
			double mu1, double mu2) {
		super(frame, lon, lat, epoch, mu1, mu2);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astroframe frame, double lon, double lat, double epoch,
			double[] eepos, double mu1, double mu2, double epocho,
			double[] eepm, double[] plx2, double[] rv2) {
		super(frame, lon, lat, epoch, eepos, mu1, mu2, epocho, eepm, plx2, rv2);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astroframe frame, double lon, double lat) {
		super(frame, lon, lat);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astroframe frame, String text) throws ParseException {
		super(frame, text);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(Astroframe frame) {
		super(frame);
		// TODO Auto-generated constructor stub
	}

	public AstroEpoch(String text) throws ParseException {
		super(text);
		// TODO Auto-generated constructor stub
	}

}
