package plugin;

import java.text.NumberFormat;
import java.util.Calendar;
import java.util.TimeZone;

import org.joda.time.DateTimeZone;
import org.joda.time.format.DateTimeFormatter;
import org.joda.time.format.ISODateTimeFormat;

import plop.astro.Astrotime;
/**
 * An object we can managed a calendar date at iso8601 format
 * 
 * there are diferents methods: *setCD(String) wich can permit to enter a calendar date ( 1991-05-16T06:47:05 ).
 * *getCD() wich can return calendar date if a calendar date have been enter before.
 * *getJyr()  wich can return a julian Year if a calendar date have been enter before.
 * 
 * @author mahler
 */
public class CalenderDate {

	private static String date ;

	static double jd;
	
	/**
	 * 
	 * @return the calendar date
	 */
	public static String getCD(){
		return date;
	}

	/**
	 * 
	 * @param cd string containing a calendar date (1991-05-16T06:47:05)
	 */
	public static void setCD(String cd){

		date=cd;
		CD2JD(date);
	}
	/**
	 * 
	 * @return the julian year corresponding at the calendar date
	 */
	public static double getJyr(){

		//Calc();
		double ndate = Astrotime.JD2J(jd);
		return ndate;
	}
	/**
	 * 
	 * @param j double represent a julian Year which convert in a Calendar date
	 */
	public static void setJ(double j){

		jd=Astrotime.J2JD(j);
		date=JD2ymdhms(jd);

	}
	/**
	 * 
	 * @param j String represent a julian Year which convert in a Calendar date
	 */
	public static void setJ(String j){

		jd=Astrotime.J2JD(Double.parseDouble(j));
		date=JD2ymdhms(jd);
	}
	/**
	 * 
	 * @return the julian day corresponding at the calendar date
	 */
	public static double getJD(){
		return jd;
	}
	/**
	 * 
	 * @return the modified julian day corresponding at the calendar date
	 */
	public static double getMJD(){
		double mjd;
		mjd=Astrotime.JD2MJD(jd);
		return mjd;
	}
	public static String JD2ymdhms(double y) {
		int[] ymd = new int[4];
		NumberFormat nf=NumberFormat.getInstance(); // Get Instance of NumberFormat
		nf.setMinimumIntegerDigits(2);  // The minimum Digits required is 2
		nf.setMaximumIntegerDigits(2); // The maximum Digits required is 2


		Astrotime.JD2YMD(y, ymd);
		Calendar date = Calendar.getInstance();
		date.setTimeZone(TimeZone.getTimeZone("GMT+00"));
		date.setTimeInMillis(Astrotime.JD2ms(y));

		String jiso = String.valueOf(ymd[0])+ "-" +  nf.format((ymd[1]+1))+ "-" + nf.format(ymd[2]) + "T" + nf.format(date.get(Calendar.HOUR_OF_DAY)) + ":" + nf.format(date.get(Calendar.MINUTE)) + ":" + nf.format(date.get(Calendar.SECOND) );
		//System.out.println("Calendar Date : " +jiso);
		//System.out.println("Calendar other Date " +ymd[0]+" "+ ymd[3]+"day   "+ date.get(Calendar.HOUR_OF_DAY) + "h " + date.get(Calendar.MINUTE) + "min  " + date.get(Calendar.SECOND)+"sec" );

		return jiso;}

	public static void CD2JD(String date){
		DateTimeZone.setDefault(DateTimeZone.UTC);
		DateTimeFormatter dtf = ISODateTimeFormat.dateOptionalTimeParser();
		long millis = dtf.parseMillis(date);// millisecond depuis 1970
		jd=Astrotime.ms2JD(millis);
	}
/*
	public static void JD2CD(String date){
		DateTimeZone.setDefault(DateTimeZone.UTC);
		DateTimeFormatter dateTime;
		DateTimeFormatter dtf = ISODateTimeFormat.dateOptionalTimeParser();
		dtf = dateTime(4784654564);
	}
*/

	public static void setMJD(String text) {}
	public static void setJD(String text) {}

}


