package plugin;

import plop.astro.Astrotime;
import plugin.EpochWindow.BoutonListener;
import plugin.EpochWindow.StateListener;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;
import java.util.Calendar;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSlider;
import javax.swing.SpringLayout;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import cds.aladin.AladinException;

public class EpochWindow extends JFrame{

	private final EpochPlug epochPlug;
	private JPanel container = new JPanel();
	private JFormattedTextField jtf = new JFormattedTextField();
	private JCheckBox check1 = new JCheckBox("je deplace la checkbox");
	JComboBox combo = new JComboBox();
	JComboBox combo2 = new JComboBox();

	JLabel label = new JLabel("Date :");
	JLabel catalogue = new JLabel("Catalogue :");
	JLabel image = new JLabel("Image :");
	JLabel inddateformat = new JLabel("Choisir le format de date :");
	private JButton b = new JButton ("OK");
	private JLabel txt1 = new JLabel("");
	private JLabel txt2 = new JLabel( "" );
	private JLabel txt3 = new JLabel( "" );
	private JLabel txt4 = new JLabel( "" );
	static JRadioButton jr1 = new JRadioButton("Année decimal");
	static JRadioButton jr2 = new JRadioButton("Jour julian");
	static JRadioButton jr3 = new JRadioButton("MJD");
	static JRadioButton jr4 = new JRadioButton("iso8601");
	ButtonGroup bg = new ButtonGroup();
	JSlider slide = new JSlider();
	static String flip ="";
	double dFormat=2000;
	SpringLayout layout = new SpringLayout();


	public EpochWindow(final EpochPlug epochPlug) throws AladinException {
		setLayout(layout);
		this.epochPlug = epochPlug;
		this.setTitle("Plugin Epoch : analyse temporelle v0.3");
		//this.setSize(900, 300);
		this.setSize(450, 400);
		// this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setLocationRelativeTo(null);

		container.setBackground(Color.white);
		container.setLayout(new BorderLayout());

		String[] tab = epochPlug.getCatName();
		String[] tab2 = epochPlug.getImName();
		combo = new JComboBox(tab);
		combo.addActionListener(new ItemAction());
		combo.setPreferredSize(new Dimension(250,20));
		combo.setForeground(Color.blue);
		combo2 = new JComboBox(tab2);
		combo2.addActionListener(new ItemAction());
		combo2.setPreferredSize(new Dimension(250,20));
		combo2.setForeground(Color.blue);

		//JPanel top = new JPanel();        
		//JPanel top1 = new JPanel();
		//JPanel top2 = new JPanel();
		//JPanel top3 = new JPanel();

		Font police = new Font("Arial", Font.BOLD, 14);
		jtf.setFont(police);
		jtf.setPreferredSize(new Dimension(220, 30));
		jtf.setForeground(Color.ORANGE);
		jtf.setText(Double.toString(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		txt1.setText("Jour Julian :"+epochPlug.JtoJD(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		txt2.setText("MJD :"+epochPlug.JtoMJD(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		txt3.setText("iso8601 :"+epochPlug.J2ymdhms(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		txt4.setText("Année julian :"+(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));

		b.addActionListener(new BoutonListener());
		check1.addActionListener(new StateListener());
		jr1.addActionListener(new StateListener());
		jr2.addActionListener(new StateListener());
		jr3.addActionListener(new StateListener());
		jr4.addActionListener(new StateListener());

		jr1.setSelected(true);

		slide.setMaximum(2020);
		slide.setMinimum(1800);
		slide.setValue((int) (epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		slide.setPaintTicks(true);
		slide.setPaintLabels(true);
		slide.setMinorTickSpacing(20);
		slide.setMajorTickSpacing(50);
		slide.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent event){
				if(jr1.isSelected()){
					jtf.setText(Double.toString( ((JSlider)event.getSource()).getValue()));}
				if(jr2.isSelected()){
					JulianDay.setJ(( ((JSlider)event.getSource()).getValue()));
					jtf.setText(Double.toString(JulianDay.getJD()));}
				if(jr3.isSelected()){
					ModJulianDay.setJ(( ((JSlider)event.getSource()).getValue()));
					jtf.setText(Double.toString(ModJulianDay.getMJD()));}
				if(jr4.isSelected()){
					jr1.setSelected(true);}
				txt1.setText("Jour Julian :"+epochPlug.JtoJD(Double.parseDouble(Double.toString( ((JSlider)event.getSource()).getValue()))));
				txt2.setText("MJD :"+epochPlug.JtoMJD(Double.parseDouble(Double.toString( ((JSlider)event.getSource()).getValue()))));
				txt3.setText("iso8601 :"+epochPlug.J2ymdhms(Double.parseDouble(Double.toString( ((JSlider)event.getSource()).getValue()))));
				txt4.setText("Année julian :"+(Double.parseDouble(Double.toString( ((JSlider)event.getSource()).getValue()))));
			}
		});

		bg.add(jr1);
		bg.add(jr2);
		bg.add(jr3);
		bg.add(jr4);
		/*
		top.add(label);
		top.add(jtf);
		top.add(b);
		top.add(combo);
		top.add(combo2);
		top1.add(jr1);
		top1.add(jr2);
		top1.add(jr3);
		top1.add(jr4);
		top2.add(slide);
		add(check1);
		top3.add(txt1);
		top3.add(txt2);
		top3.add(txt3);
		top3.add(txt4);

		container.add(top, BorderLayout.NORTH);
		container.add(top3, BorderLayout.SOUTH);
		container.add(top2, BorderLayout.WEST);
		container.add(top1, BorderLayout.CENTER);
//*/
		
		add(label);
		add(catalogue);
		add(image);
		add(jtf);
		add(b);
		add(combo);
		add(combo2);
		add(jr1);
		add(jr2);
		add(jr3);
		add(jr4);
		add(slide);
		//add(check1);
		add(txt1);
		add(txt2);
		add(txt3);
		add(txt4);
		add(inddateformat);
		
		//layout.putConstraint(SpringLayout.WEST,check1,300,SpringLayout.WEST,this);
		//layout.putConstraint(SpringLayout.NORTH,check1,150,SpringLayout.NORTH,this);
		//*definir la taile de la fenetre a 350,600

		layout.putConstraint(SpringLayout.WEST,label,25,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,label,15,SpringLayout.NORTH,this);

		  layout.putConstraint(SpringLayout.WEST,jtf,25,SpringLayout.EAST,label);
		layout.putConstraint(SpringLayout.NORTH,jtf,12,SpringLayout.NORTH,this);
		
		 layout.putConstraint(SpringLayout.WEST,b,10,SpringLayout.EAST,jtf);
		layout.putConstraint(SpringLayout.NORTH,b,12,SpringLayout.NORTH,this);

		
		layout.putConstraint(SpringLayout.WEST,inddateformat,20,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,inddateformat,30,SpringLayout.SOUTH,jtf);
		
		 layout.putConstraint(SpringLayout.WEST,jr1,20,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,jr1,7,SpringLayout.SOUTH,inddateformat);

		 layout.putConstraint(SpringLayout.WEST,jr2,10,SpringLayout.EAST,jr1);
		layout.putConstraint(SpringLayout.NORTH,jr2,7,SpringLayout.SOUTH,inddateformat);

		layout.putConstraint(SpringLayout.WEST,jr3,10,SpringLayout.EAST,jr2);
		layout.putConstraint(SpringLayout.NORTH,jr3,7,SpringLayout.SOUTH,inddateformat);

		 layout.putConstraint(SpringLayout.WEST,jr4,10,SpringLayout.EAST,jr3);
		layout.putConstraint(SpringLayout.NORTH,jr4,7,SpringLayout.SOUTH,inddateformat);
//de la
		layout.putConstraint(SpringLayout.WEST,catalogue,20,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,catalogue,30,SpringLayout.SOUTH,jr1);
		
        layout.putConstraint(SpringLayout.WEST,combo,10,SpringLayout.EAST,catalogue);
		layout.putConstraint(SpringLayout.NORTH,combo,30,SpringLayout.SOUTH,jr1);
//a la  et de la		
		layout.putConstraint(SpringLayout.WEST,image,20,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,image,10,SpringLayout.SOUTH,catalogue);
		
        layout.putConstraint(SpringLayout.WEST,combo2,10,SpringLayout.EAST,catalogue);
		layout.putConstraint(SpringLayout.NORTH,combo2,10,SpringLayout.SOUTH,catalogue);
//	a la	
		layout.putConstraint(SpringLayout.WEST,slide,45,SpringLayout.EAST,this);
		layout.putConstraint(SpringLayout.NORTH,slide,20,SpringLayout.SOUTH,image);
		
		//1:JD 2:MDJ 3:iso 4:J
		
		layout.putConstraint(SpringLayout.WEST,txt3,10,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,txt3,20,SpringLayout.SOUTH,slide);
		
		layout.putConstraint(SpringLayout.WEST,txt1,10,SpringLayout.WEST,this);
		layout.putConstraint(SpringLayout.NORTH,txt1,20,SpringLayout.SOUTH,txt3);
		
		layout.putConstraint(SpringLayout.WEST,txt2,10,SpringLayout.EAST,txt3);
		layout.putConstraint(SpringLayout.NORTH,txt2,20,SpringLayout.SOUTH,txt3);
		
		layout.putConstraint(SpringLayout.WEST,txt4,10,SpringLayout.EAST,txt3);
		layout.putConstraint(SpringLayout.NORTH,txt4,20,SpringLayout.SOUTH,slide);
		
		
		// */
		//this.setContentPane(container);
		this.setVisible(true); 
		jtf.setText(Double.toString(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
		jr1.setSelected(true);
		CurrentDateFormat.currentDateFormat=1;
		JulianYear.setJY(jtf.getText());
	}




	class BoutonListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			if(EpochWindow.jr1.isSelected()){
				JulianYear.setJY(jtf.getText());
				JulianDay.setJ(jtf.getText());
			  ModJulianDay.setJ(jtf.getText());
				CalenderDate.setJ(jtf.getText());
			
			}
			if(EpochWindow.jr2.isSelected()){
				JulianDay.setJD(jtf.getText());
				JulianYear.setJD(jtf.getText());
			    ModJulianDay.setJD(jtf.getText());
		    	CalenderDate.setJD(jtf.getText());	
				
			}
			if(EpochWindow.jr3.isSelected()){
			   ModJulianDay.setMJD(jtf.getText());
		       JulianYear.setMJD(jtf.getText());
			   JulianDay.setMJD(jtf.getText());
			 CalenderDate.setMJD(jtf.getText());
				
			}
			if(EpochWindow.jr4.isSelected()){
				CalenderDate.setCD(jtf.getText());
				ModJulianDay.setCD(jtf.getText());
			    JulianYear.setCD(jtf.getText());
				JulianDay.setCD(jtf.getText());
				
				
			}
			String flip =jtf.getText() ;
/*
			txt1.setText("Jour Julian :"+JulianDay.getJD());
			txt2.setText("MJD :"+ModJulianDay.getMJD());
			txt3.setText("iso8601 :"+CalenderDate.getCD());
			txt4.setText("Année julian :"+JulianYear.getJY());
	*/		
			try {
				double flipD = Double.parseDouble(flip);
				System.out.println("flipD = " + flipD);
				epochPlug.newCoords();
			} catch (NumberFormatException e1) {
				e1.printStackTrace();
			} catch (ParseException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}


		}
	}

	class StateListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {

			if(jr1.isSelected()){
				System.out.println(jr1.getText()+" "+CurrentDateFormat.currentDateFormat);
				CurrentDateFormat.convert(CurrentDateFormat.currentDateFormat, 1);
				jtf.setText(Double.toString(JulianYear.getJY()));
				CurrentDateFormat.currentDateFormat=1;
			}
			if(jr2.isSelected()){
				System.out.println(jr2.getText()+" "+CurrentDateFormat.currentDateFormat);
				CurrentDateFormat.convert(CurrentDateFormat.currentDateFormat, 2);
				jtf.setText(Double.toString(JulianDay.getJD()));
				CurrentDateFormat.currentDateFormat=2;
			}
			if(jr3.isSelected()){
				System.out.println(jr3.getText()+" "+CurrentDateFormat.currentDateFormat);
				CurrentDateFormat.convert(CurrentDateFormat.currentDateFormat, 3);
				jtf.setText(Double.toString(ModJulianDay.getMJD()));
				CurrentDateFormat.currentDateFormat=3;
			}
			if(jr4.isSelected()){
				System.out.println(jr4.getText()+" "+CurrentDateFormat.currentDateFormat);
				CurrentDateFormat.convert(CurrentDateFormat.currentDateFormat, 4);
				jtf.setText(CalenderDate.getCD());
				CurrentDateFormat.currentDateFormat=4;
			}

			/*

			System.out.println("source : " + jr1.getText() + " - état : " + jr1.isSelected());
			System.out.println("source : " + jr2.getText() + " - état : " + jr2.isSelected());
			System.out.println("source : " + jr3.getText() + " - état : " + jr3.isSelected());
			System.out.println("source : " + jr4.getText() + " - état : " + jr4.isSelected());//*/
		}}

	class ItemAction implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			System.out.println("ActionListener : action sur " + combo.getSelectedItem());
			System.out.println("ActionListener : action sur " + combo2.getSelectedItem());
			try {
				slide.setValue((int) (epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				jtf.setText(Double.toString(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				txt1.setText("Jour Julian :"+epochPlug.JtoJD(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				txt2.setText("MJD :"+epochPlug.JtoMJD(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				txt3.setText("iso8601 :"+epochPlug.J2ymdhms(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				txt4.setText("Année julian :"+(epochPlug.getImageEpoch(combo2.getSelectedItem().toString())));
				jr1.setSelected(true);
				CurrentDateFormat.currentDateFormat=1;
				JulianYear.setJY(jtf.getText());
			} catch (AladinException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}}}
}