package plugin;

import java.text.NumberFormat;
import java.util.Calendar;
import java.util.TimeZone;

import plop.astro.Astrotime;
/**
 * An object we can managed a julian day
 * 
 * there are diferents methods: *setJD(double or String) wich can permit to enter a julian day ( 2451545.5 ).
 * *getJD() wich can return the julian day if a julian day have been enter before.
 * *getJyr()  wich can return a julian Year if a julian day have been enter before.
 * 
 * @author mahler
 */
public class JulianDay {

	private static double date;

	/**
	 * 
	 * @return the julian day
	 */
	public static double getJD(){
		return date;
	}
	/**
	 * 
	 * @param jd double containing the julian day
	 */
	public static void setJD(double jd){

		date=jd;
	}
	/**
	 * 
	 * @param jd String containing the julian day
	 */
	public static void setJD(String jd){

		date=Double.parseDouble(jd);
	}
	/**
	 * 
	 * @return the julian year corresponding at the julian day
	 */
	public static double getJyr(){
		double j; 
		j =Astrotime.JD2J(date);
		return j;
	}
	/**
	 * 
	 * @param j double represent a julian Year which convert in a julian day 
	 */
	public static void setJ(double j){

		date=Astrotime.J2JD(j);
	}
	/**
	 * 
	 * @param j String represent a julian Year which convert in a julian day 
	 */
	public static void setJ(String j){

		date=Astrotime.J2JD(Double.parseDouble(j));
	}
	/**
	 * 
	 * @return the modified julian day corresponding at the julian day
	 */
	public static double getMJD(){
		double mjd;
		mjd =Astrotime.JD2MJD(date);
		return mjd;
	}/**
	 * 
	 * @return the calendar date corresponding at the julian day
	 */
	public static String getCD(){
		String  jiso;
		jiso=JD2ymdhms(date);
		return jiso;
	}
	public static void setMJD(String s){
		date=Astrotime.MJD2JD(Double.parseDouble(s));
	}
	public static void setMJD(double d){
		date=Astrotime.MJD2JD(d);
	}
	public static void setCD(String s){}
	
	public static String JD2ymdhms(double y) {
		int[] ymd = new int[4];
		NumberFormat nf=NumberFormat.getInstance(); // Get Instance of NumberFormat
		nf.setMinimumIntegerDigits(2);  // The minimum Digits required is 2
		nf.setMaximumIntegerDigits(2); // The maximum Digits required is 2


		Astrotime.JD2YMD(y, ymd);
		Calendar date = Calendar.getInstance();
		date.setTimeZone(TimeZone.getTimeZone("GMT+00"));
		date.setTimeInMillis(Astrotime.JD2ms(y));

		String jiso = String.valueOf(ymd[0])+ "-" +  nf.format((ymd[1]+1))+ "-" + nf.format(ymd[2]) + "T" + nf.format(date.get(Calendar.HOUR_OF_DAY)) + ":" + nf.format(date.get(Calendar.MINUTE)) + ":" + nf.format(date.get(Calendar.SECOND) );
		//System.out.println("Calendar Date : " +jiso);
		//System.out.println("Calendar other Date " +ymd[0]+" "+ ymd[3]+"day   "+ date.get(Calendar.HOUR_OF_DAY) + "h " + date.get(Calendar.MINUTE) + "min  " + date.get(Calendar.SECOND)+"sec" );

		return jiso;}

}
