package plugin;

import java.text.NumberFormat;
import java.util.Calendar;
import java.util.TimeZone;

import org.joda.time.DateTimeZone;
import org.joda.time.format.DateTimeFormatter;
import org.joda.time.format.ISODateTimeFormat;

import plop.astro.Astrotime;

/**
 * An object we can managed a julian year
 * 
 * there are diferents methods: *setJY(double or String) wich can permit to enter a julian year ( 1991.5678942 )
 * *getJY() wich can return the julian Year if a julian year have been enter before
 * 
 * @author mahler
 */
public class JulianYear {

	private static double date;

	/**
	 * 
	 * @returnthe julian year
	 */
	public static double getJY(){
		return date;
	}
	/**
	 * 
	 * @param jy double containing the julian year
	 */
	public static void setJY(double jy){

		date=jy;
	}
	/**
	 * 
	 * @param jy String containing the julian year
	 */
	public static void setJY(String jy){

		date=Double.parseDouble(jy);
	}
	/**
	 * 
	 * @return the julian day corresponding at the julian year
	 */
	public static double getJD(){
		double jd ;
		jd=Astrotime.J2JD(date);
		return jd;
	}
	/**
	 * 
	 * @return the modified julian day corresponding at the julian year
	 */
	public static double getMJD(){
		double mjd ;
		mjd=Astrotime.J2JD(date);
		mjd=Astrotime.JD2MJD(mjd);
		return mjd;
	}
	/**
	 * 
	 * @return the calendar corresponding at the julian year
	 */
	public static String getCD(){
		String  jiso;
		jiso=J2ymdhms(date);
		return jiso;
	}
	public static void setJD(String s){
		date =Astrotime.JD2J(Double.parseDouble(s));
		
	}
	public static void setJD(double d){
		date =Astrotime.JD2J(d);
		
	}
	public static void setMJD(String s){
		double y;
		y=Astrotime.MJD2JD(Double.parseDouble(s));
		date=Astrotime.JD2J(y);
		
	}
	public static void setMJD(double d){
		double y;
		y=Astrotime.MJD2JD(d);
		date=Astrotime.JD2J(y);
		
	}
	public static void setCD(String s){}
	
	/*
	public static void J2CD(){
		DateTimeFormatter dtf = ISODateTimeFormat.dateOptionalTimeParser();
		long millis = dtf.parseMillis("1951-03-02T07:01:12");// millisecond depuis 1970
		Astrotime.ms2JD(millis);


		DateTimeZone.setDefault(DateTimeZone.UTC);
		dtf = ISODateTimeFormat.dateOptionalTimeParser();
		millis = dtf.parseMillis("1951-03-02T07:01:12");
		System.out.println("Parsing de 1951-03-02T07:01:12 : "+millis);
		millis = dtf.parseMillis("1951-03-02");
		System.out.println("Parsing de 1951-03-02 : "+millis);
		millis = dtf.parseMillis("1951-03-02T07:01:12.525");
		System.out.println("Parsing de 1951-03-02T07:01:12.525 : "+millis);
	}
	*/
	public static String J2ymdhms(double y) {
		//Cette methode prend normalement des jours Julian je reconvertis donc l'année julian rentrer en parametre en jour Julian
		y=Astrotime.J2JD(y);
		int[] ymd = new int[4];
		NumberFormat nf=NumberFormat.getInstance(); // Get Instance of NumberFormat
		nf.setMinimumIntegerDigits(2);  // The minimum Digits required is 2
		nf.setMaximumIntegerDigits(2); // The maximum Digits required is 2


		Astrotime.JD2YMD(y, ymd);
		Calendar date = Calendar.getInstance();
		date.setTimeZone(TimeZone.getTimeZone("GMT+00"));
		date.setTimeInMillis(Astrotime.JD2ms(y));

		String jiso = String.valueOf(ymd[0])+ "-" +  nf.format((ymd[1]+1))+ "-" + nf.format(ymd[2]) + "T" + nf.format(date.get(Calendar.HOUR_OF_DAY)) + ":" + nf.format(date.get(Calendar.MINUTE)) + ":" + nf.format(date.get(Calendar.SECOND) );
		//System.out.println("Calendar Date : " +jiso);
		//System.out.println("Calendar other Date " +ymd[0]+" "+ ymd[3]+"day   "+ date.get(Calendar.HOUR_OF_DAY) + "h " + date.get(Calendar.MINUTE) + "min  " + date.get(Calendar.SECOND)+"sec" );

		return jiso;}
}
