package plugin;

import java.text.NumberFormat;
import java.util.Calendar;
import java.util.TimeZone;

import plop.astro.Astrotime;
/**
 * An object we can managed a modified julian day
 * 
 * there are diferents methods: *setMJD(double or String) wich can permit to enter a modified julian day ( 51545.0 ).
 * *getMJD() wich can return the modified julian day if a modified julian day have been enter before.
 * *getJyr()  wich can return a julian Year if a modified julian day have been enter before.
 * 
 * @author mahler
 */
public class ModJulianDay {

	private static double date;

	/**
	 * 
	 * @return the modified julian day
	 */
	public static double getMJD(){
		return date;
	}
	/**
	 * 
	 * @param mjd double containing a modified julian day
	 */
	public static  void setMJD(double mjd){

		date=mjd;
	}
	/**
	 * 
	 * @param mjd String containing a modified julian day
	 */
	public static void setMJD(String mjd){

		date=Double.parseDouble(mjd);
	}
	/**
	 * 
	 * @return the julian year corresponding at the modified julian day
	 */
	public static double getJyr(){
		double jy ;
		jy =Astrotime.MJD2JD(date);
		jy =Astrotime.JD2J(jy);
		return jy;
	}
	/**
	 * 
	 * @param j double represent a julian Year which convert in Modified julian day 
	 */
	public static void setJ(double j){

		date=Astrotime.J2JD(j);
		date=Astrotime.JD2MJD(date);
	}
	/**
	 * 
	 * @param j String represent a julian Year which convert in a Modified julian day 
	 */
	public static void setJ(String j){

		date=Astrotime.J2JD(Double.parseDouble(j));
		date=Astrotime.JD2MJD(date);
	}
	/**
	 * 
	 * @return the julian day corresponding at the modified julian day
	 */
	public static double getJD(){
		double jd;
		jd =Astrotime.MJD2JD(date);

		return jd;
	}
	/**
	 * 
	 * @return the calendar date corresponding at the modified julian day
	 */
	public static String getCD(){
		String  jiso;
		jiso=MJD2ymdhms(date);
		return jiso;
	}
	
	public static void setJD(String s){
		date =Astrotime.JD2MJD(Double.parseDouble(s));
		
	}
	public static void setJD(double d){
		date =Astrotime.JD2MJD(d);
		
	}	
	
	public static void setCD(String s){}
	
	public static String MJD2ymdhms(double y) {
		//Cette methode prend normalement des jours Julian je reconvertis donc les jours julian modifié rentrer en parametre en jour Julian
		y=Astrotime.MJD2JD(y);
		int[] ymd = new int[4];
		NumberFormat nf=NumberFormat.getInstance(); // Get Instance of NumberFormat
		nf.setMinimumIntegerDigits(2);  // The minimum Digits required is 2
		nf.setMaximumIntegerDigits(2); // The maximum Digits required is 2


		Astrotime.JD2YMD(y, ymd);
		Calendar date = Calendar.getInstance();
		date.setTimeZone(TimeZone.getTimeZone("GMT+00"));
		date.setTimeInMillis(Astrotime.JD2ms(y));

		String jiso = String.valueOf(ymd[0])+ "-" +  nf.format((ymd[1]+1))+ "-" + nf.format(ymd[2]) + "T" + nf.format(date.get(Calendar.HOUR_OF_DAY)) + ":" + nf.format(date.get(Calendar.MINUTE)) + ":" + nf.format(date.get(Calendar.SECOND) );
		//System.out.println("Calendar Date : " +jiso);
		//System.out.println("Calendar other Date " +ymd[0]+" "+ ymd[3]+"day   "+ date.get(Calendar.HOUR_OF_DAY) + "h " + date.get(Calendar.MINUTE) + "min  " + date.get(Calendar.SECOND)+"sec" );

		return jiso;}
}
